Package com.io7m.jregions.core.unparameterized.sizes

# Class VolumeSizeBI

java.lang.Object
com.io7m.jregions.core.unparameterized.sizes.VolumeSizeBI

All Implemented Interfaces:
  `VolumeSizeBIType`, `VolumeSizeValuesBIType`

    public final class VolumeSizeBI
    extends java.lang.Object
    implements VolumeSizeBIType

The size of a volume with `BigInteger` coordinates.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `VolumeSizeBI.Builder` | Builds instances of type `VolumeSizeBI`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static VolumeSizeBI.Builder` | `builder()` | Creates a builder for `VolumeSizeBI`.
  `static VolumeSizeBI` | `copyOf​(VolumeSizeBIType instance)` | Creates an immutable copy of a `VolumeSizeBIType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `VolumeSizeBI` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `sizeX`, `sizeY`, `sizeZ`.
  `static VolumeSizeBI` | `of​(java.math.BigInteger sizeX, java.math.BigInteger sizeY, java.math.BigInteger sizeZ)` | Construct a new immutable `VolumeSizeBI` instance.
  `java.math.BigInteger` | `sizeX()` |
  `java.math.BigInteger` | `sizeY()` |
  `java.math.BigInteger` | `sizeZ()` |
  `java.lang.String` | `toString()` | Prints the immutable value `VolumeSizeBI` with attribute values.
  `VolumeSizeBI` | `withSizeX​(java.math.BigInteger value)` | Copy the current immutable object by setting a value for the `sizeX` attribute.
  `VolumeSizeBI` | `withSizeY​(java.math.BigInteger value)` | Copy the current immutable object by setting a value for the `sizeY` attribute.
  `VolumeSizeBI` | `withSizeZ​(java.math.BigInteger value)` | Copy the current immutable object by setting a value for the `sizeZ` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### sizeX

    public java.math.BigInteger sizeX()
    Specified by:
      `sizeX` in interface `VolumeSizeBIType`
    Specified by:
      `sizeX` in interface `VolumeSizeValuesBIType`
    Returns:
      The value of the `sizeX` attribute

  - ### sizeY

    public java.math.BigInteger sizeY()
    Specified by:
      `sizeY` in interface `VolumeSizeBIType`
    Specified by:
      `sizeY` in interface `VolumeSizeValuesBIType`
    Returns:
      The value of the `sizeY` attribute

  - ### sizeZ

    public java.math.BigInteger sizeZ()
    Specified by:
      `sizeZ` in interface `VolumeSizeBIType`
    Specified by:
      `sizeZ` in interface `VolumeSizeValuesBIType`
    Returns:
      The value of the `sizeZ` attribute

  - ### withSizeX

    public final VolumeSizeBI withSizeX​(java.math.BigInteger value)
    Copy the current immutable object by setting a value for the `sizeX` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for sizeX
    Returns:
      A modified copy of the `this` object

  - ### withSizeY

    public final VolumeSizeBI withSizeY​(java.math.BigInteger value)
    Copy the current immutable object by setting a value for the `sizeY` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for sizeY
    Returns:
      A modified copy of the `this` object

  - ### withSizeZ

    public final VolumeSizeBI withSizeZ​(java.math.BigInteger value)
    Copy the current immutable object by setting a value for the `sizeZ` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for sizeZ
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `VolumeSizeBI` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `sizeX`, `sizeY`, `sizeZ`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `VolumeSizeBI` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### of

    public static VolumeSizeBI of​(java.math.BigInteger sizeX, java.math.BigInteger sizeY, java.math.BigInteger sizeZ)
    Construct a new immutable `VolumeSizeBI` instance.
    Parameters:
      `sizeX` - The value for the `sizeX` attribute
      `sizeY` - The value for the `sizeY` attribute
      `sizeZ` - The value for the `sizeZ` attribute
    Returns:
      An immutable VolumeSizeBI instance

  - ### copyOf

    public static VolumeSizeBI copyOf​(VolumeSizeBIType instance)
    Creates an immutable copy of a `VolumeSizeBIType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VolumeSizeBI instance

  - ### builder

    public static VolumeSizeBI.Builder builder()
    Creates a builder for `VolumeSizeBI`.

         VolumeSizeBI.builder()
            .setSizeX(java.math.BigInteger) // required sizeX
            .setSizeY(java.math.BigInteger) // required sizeY
            .setSizeZ(java.math.BigInteger) // required sizeZ
            .build();

    Returns:
      A new VolumeSizeBI builder